% PLOT CONFIGURATION
% Plot style configurations.
%
% Author: Pablo Pizarro @ppizarror.com, 2017.
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; either version 2
% of the License, or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

% --------------------------------------------------------------------
% PLOT STYLES (COLOR, SYMBOL, LINEWIDTH)

% Dispersion plot style
plt_dispersion_style = 'rs-';

% Solution dispersion curve plot style - experimental curve errorbar
solution_plt_dispersion_experimental_style = 'ro--';

% Solution dispersion curve plot style - solution
solution_plt_dispersion_solution_style = 'b-';

% Solution shear plot curve style
solution_plt_shear_curve_style = 'r';

% Solution shear plot comparision curve shear style
solution_shear_comparision_shear_curve_style = 'r';

% Solution shear plot comparision initial guess style
solution_shear_comparision_iguess_curve_style = 'k--';

% Dispersion curve vs iteration plot style
dispersion_iteration_style = '-';

% Dispersion curve vs iteration plot color (r, g, b, k)
dispersion_iteration_color = 'r';

% Dispersion curve vs iteration plot random color
dispersion_iteration_random_color = false;

% Dispersion curve vs iteration plot linewidth
dispersion_iteration_linewidth = 1;

% Dispersion plot linewidth
plt_dispersion_linewidth = 1;

% Solution dispersion curve plot - experimental curve linewidth
solution_plt_dispersion_experimental_linewidth = 1;

% Solution plot dispersion curve plot linewidth
solution_plt_dispersion_linewidth = 1;

% Shear curve plot linewidth
solution_plot_shear_linewidth = 1.2;

% Solution shear plot comparision curve linewidth
solution_shear_comparision_shear_curve_linewidth = 1.2;

% Solution shear plot comparision initial guess linewidth
solution_shear_comparision_iguess_curve_linewidth = 1.0;
% --------------------------------------------------------------------


% --------------------------------------------------------------------
% PLOT LABEL FONTSIZE

% Dispersion plot label fontsize
plt_dispersion_label_fontsize = 10;

% Solution plot label fontsize
solution_plt_dispersion_fontsize = 10;

% Solution shear plot fontsize
solution_plt_shear_fontsize = 10;

% Dispersion curve vs iteration fontsize
dispersion_iteration_fontsize = 10;

% Solution shear comparision plot fontsize
solution_shear_comparision_fontsize = 10;
% --------------------------------------------------------------------


% --------------------------------------------------------------------
% PLOT SHOW LEGEND

% Show legend on experimental dispersion curve
plt_dispersion_show_legend = true;

% Show legend on solution dispersion curve plot
solution_plt_dispersion_show_legend = true;

% Show legend on shear curve plot
solution_plt_shear_show_legend = true;

% Show legend on dispersion iteration plot
dispersion_iteration_show_legend = true;

% Show legend on shear comparision
solution_plt_shear_comparision_legend = true;
% --------------------------------------------------------------------

